' RADIOCARBON TO CALENDAR DATE CONVERSION
' 14C -> Cal
' Prepared by Brian Williams


[dimensions]

 dim Array$(77,3)
 dim Array (77,3)
 dim row(77)
 dim col(3)


[start]

  open "IntCal20-data.csv" for input as #1
    while eof(#1)=0
    for row=1 to 77
      for col=1 to 3
        input #1, Array$(row,col)
        Array(row,col)=val(Array$(row,col)) ' converts data input string to numerical value
      next col
    next row
    wend
  close #1

  print
  print "  RADIOCARBON TO CALENDAR DATE CONVERSION (14C -> Cal)"
  print "  Based on the IntCal20 Northern Hemisphere curve"
  print "  Prepared by Brian Williams"
  print
  print "  All dates are BP, meaning Before Present, as measured from AD 1950"
  print "  Input range is 2944 to 21155 radiocarbon years"
  print
  print "  The program recognises 75 relevant points at which the atmospheric 14C:12C ratio has altered"
  print "  These points accord with fluctuations in the MIS (Marine Isotope Stage) record"
  print "  Results should be treated as estimates, with typical variation 200 years"
  print "  Whilst every care is taken, no liabilty is implied"


[input]

  print: print
  input "  enter radiocarbon date (no comma): "; rcdate
    if rcdate<2944 or rcdate>21155 then print "  input outside of calculator's range ": goto [input]
    if rcdate=2944 then calyears=2967: goto [results]
    if rcdate=21155 then calyears=25426: goto [results]


[calculation]

' rc = radiocarbon (14C) years
' seg = segment between points of relevant change on IntCal20 curve

  for row=1 to 77
    if rcdate<(Array(row,1)+1) then exit for
  next

  rcseg=Array(row,1)-Array((row-1),1)
  calseg=Array(row,2)-Array((row-1),2)
  ratio=calseg/rcseg
  rcpartseg=rcdate-Array((row-1),1)
  calpartseg=rcpartseg*ratio
  calyears=Array((row-1),2)+calpartseg


[results]
  calyears=int(calyears+0.5)
  print "  radiocarbon years (14C) "; rcdate; " convert to "; calyears; " calendar years"
  print


[another]

  print "  for another input, press y and Enter, or Enter to end program"
  input "  >  "; y$
  if y$="y" or y$="Y" then goto [input]


[End]
  print
  print "  ___________________________________________________________________________"
  print
  print "  Program ends"
  end

